// ----------------------------------------------------------------------------
//
// frmMain(AnaUM.PAS)                                    Ulrich Mller 16.10.01
//                                                       Procida 400NT Delphi 4
// Kontinuierliche Anzeige der Werte des A-Einganges EY des
// fischertechnik Interfaces 30 402 (Intelligent) an COM1
// unter Einsatz von umAnalog
//
// ----------------------------------------------------------------------------

unit AnaUM;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  umFishEx, umAnalog, StdCtrls, ExtCtrls;

type
  TfrmMain = class(TForm)
    cmdAction: TButton;
    cmdEnde: TButton;
    lblHinweis: TStaticText;
    picAnalog: TPaintBox;
    procedure cmdEndeClick(Sender: TObject);
    procedure cmdActionClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormResize(Sender: TObject);
    procedure FormPaint(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  frmMain: TfrmMain;

implementation
{$R *.DFM}
var
  WFest, WMin, SFest, SMin: Integer; Sperre: Boolean = false;

procedure TfrmMain.cmdEndeClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmMain.cmdActionClick(Sender: TObject);
begin
  if ftiOpenInterface('COM1') = ftiFehler then begin
    MessageDlg('InterfaceProblem : COM1', mtInformation, [mbOK], 0);
    exit;
  end;
  cmdAction.Enabled := false;
  cmdEnde.Enabled := false;
  lblHinweis.Visible := true;

  repeat
    anaShowDisplay(Self.picAnalog, ftiGetAnalog(1));
    ftiWaitForTime(100);
  until ftiFinish(1);

  ftiCloseInterface;
  lblHinweis.Visible := false;
  cmdAction.Enabled := true;
  cmdEnde.Enabled := true;
  anaShowDisplay(Self.picAnalog, 0);
  cmdEnde.SetFocus;
end;

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  WFest := ClientWidth - picAnalog.Width;
  WMin  := 200;
  SFest := ClientHeight - picAnalog.Height;
  SMin  := 250;
  anaShowDisplay(picAnalog, 0);
end;

procedure TfrmMain.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  if not cmdAction.Enabled then begin
    ftiNotHalt := true;
    CanClose := false;
  end;
end;

procedure TfrmMain.FormResize(Sender: TObject);
var
  WDelta, SDelta: Integer;
begin
  if Sperre then exit;
  Sperre := true;
  if WindowState = wsMinimized then exit;
  if Width < WMin then Width := WMin;
  if Height < SMin then Height := SMin;
  WDelta := ClientWidth  - WFest - picAnalog.Width;
  SDelta := ClientHeight - SFest - picAnalog.Height;
  cmdAction.Left := cmdAction.Left + WDelta;
  cmdAction.Top  := cmdAction.Top  + SDelta;
  cmdEnde.Left := cmdEnde.Left + WDelta;
  cmdEnde.Top  := cmdEnde.Top  + SDelta;
  lblHinweis.Top := lblHinweis.Top + SDelta;
  picAnalog.Width := picAnalog.Width + WDelta;
  picAnalog.Height := picAnalog.Height + SDelta;
  anaShowDisplay(picAnalog, 0);
  Sperre := false;
end;


procedure TfrmMain.FormPaint(Sender: TObject);
begin
  anaShowDisplay(picAnalog, 0);
end;

end.
