// ----------------------------------------------------------------------------
//
// umAnalog(umAnalog.PAS)                                Ulrich Mller 16.10.01
//                                                       Procida 400NT Delphi 4
// Zeichnen eines Analogenmegertes und Anzeige des Mewertes
// in ein TImage Control.
//
// ----------------------------------------------------------------------------

unit umAnalog;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

procedure anaShowDisplay(dsp: TPaintBox; aWert: LongInt);

implementation

procedure anaShowDisplay(dsp: TPaintBox; aWert: Integer);

const
  kStrich = 5; lStrich = 8; anzStriche = 21; sWinkel = 1.05; iRadius = 75;
  zRadius = 40; zStrich = 48; zBereich = 1000; zTeilung = 250;

var
  dWinkel, aWinkel: Single; sWert: Integer; dText: string;
  x, y: Integer; x1, y1, x2, y2: Single;
  i: LongInt;

function xD(x: Single): Integer;
begin
  Result := Round(dsp.ClientWidth * (x / 100) + dsp.ClientWidth / 2);
end;

function yD(y: Single): Integer;
begin
  Result := dsp.ClientHeight - Round(dsp.ClientHeight * ((y-20) / 80));
end;

begin
  dsp.Canvas.Brush.Color := clWhite;
  dsp.Canvas.Pen.Color := clWhite;
  dsp.Canvas.Pen.Width := 1;
  dsp.Canvas.Rectangle(0, 0, dsp.ClientWidth, dsp.ClientHeight);
  dsp.Canvas.Pen.Color := clBlack;

// --- Minor Ticks ------------

  aWinkel := sWinkel;
  dWinkel := sWinkel / (anzStriche - 1);
  for i := 1 to anzStriche do
  begin
    x1 := Cos(aWinkel) * iRadius;
    y1 := Sin(aWinkel) * iRadius;
    x2 := x1 + Cos(aWinkel) * kStrich;
    y2 := y1 + Sin(aWinkel) * kStrich;
    dsp.Canvas.MoveTo(xD(x1),yD(y1));
    dsp.Canvas.LineTo(xD(x2),yD(y2));
    aWinkel := aWinkel + dWinkel;
  end;

// --- Major Ticks --------------------

  aWinkel := sWinkel;
  sWert := zBereich;
  dWinkel := sWinkel / ((anzStriche - 1) / 5);
  for i := 1 to Round((anzStriche -1)/5+1) do
  begin
    x1 := Cos(aWinkel) * iRadius;
    y1 := Sin(aWinkel) * iRadius;
    x2 := x1 + Cos(aWinkel) * lStrich;
    y2 := y1 + Sin(aWinkel) * lStrich;
    dsp.Canvas.MoveTo(xD(x1),yD(y1));
    dsp.Canvas.LineTo(xD(x2),yD(y2));
    dsp.Canvas.TextOut(xD(x2)-7,yD(y2)-12,IntToStr(sWert));
    aWinkel := aWinkel + dWinkel;
    sWert := sWert - zTeilung;
  end;

// ----- Analog Wert -------------------------------

  dsp.Canvas.Pen.Color := clRed;
  aWinkel := sWinkel + ((zBereich-aWert) / zBereich) * sWinkel;
  x1 := Cos(aWinkel) * zRadius;
  y1 := Sin(aWinkel) * zRadius;
  x2 := x1 + Cos(aWinkel) * zStrich;
  y2 := y1 + Sin(aWinkel) * zStrich;
  dsp.Canvas.MoveTo(xD(x1),yD(y1));
  dsp.Canvas.LineTo(xd(x2),yD(y2));

// ----- Digital Wert ----------------------------

  dText := 'Wert : ' + IntToStr(aWert);
  x := (dsp.ClientWidth div 2) - (dsp.Canvas.TextWidth(dText) div 2);
  y := dsp.ClientHeight - 24;
  dsp.Canvas.TextOut(x, y, dText);
end;

end.
